#include <ell/CLatticeProteinPivotMoveStructCUBNormState.hh>
#include <fstream>	// for readBinaryInputClone(..), writeBinaryOutput(..)

namespace ell
{
	CLatticeProteinPivotMoveStructCUBNormState::CLatticeProteinPivotMoveStructCUBNormState(
	 const Structure& normStruc) {
	cStructure = compressSeq(normStruc,
							 LatticeProteinPivotMoveStructCUBNormState::
							  getCommonCUBLatticeModel()->getDescriptor()
							  ->getAlphabet());
	}

	CLatticeProteinPivotMoveStructCUBNormState::
	~CLatticeProteinPivotMoveStructCUBNormState() {
	}

	std::string
	CLatticeProteinPivotMoveStructCUBNormState::getUncompressedSeqStr() const {
		return LatticeProteinPivotMoveStructCUBNormState::
				 getCommonSequenceString();
	}

	std::string
	CLatticeProteinPivotMoveStructCUBNormState::getUncompressedStructStr() const {
			// structure string holds one character less than sequence string
		return uncompressSeq(cStructure,
							  LatticeProteinPivotMoveStructCUBNormState::
							  getCommonCUBLatticeModel()->getDescriptor()
							   ->getAlphabet(),
							  LatticeProteinPivotMoveStructCUBNormState::
							   getCommonSequenceString().size()-1);
	}

	bool	
	CLatticeProteinPivotMoveStructCUBNormState::operator== (const CState& _cState2) const {
		CLatticeProteinPivotMoveStructCUBNormState cState2 =
		 dynamic_cast<const CLatticeProteinPivotMoveStructCUBNormState&>(_cState2);
		return (this->cStructure == cState2.cStructure);
	}

	bool
	CLatticeProteinPivotMoveStructCUBNormState::operator!= (const CState& _cState2) const {
		CLatticeProteinPivotMoveStructCUBNormState cState2 =
		 dynamic_cast<const CLatticeProteinPivotMoveStructCUBNormState&>(_cState2);
		return (this->cStructure != cState2.cStructure);
	}

	CLatticeProteinPivotMoveStructCUBNormState* 
	CLatticeProteinPivotMoveStructCUBNormState::clone() const {
		return new CLatticeProteinPivotMoveStructCUBNormState(*this);
	}

	std::string
	CLatticeProteinPivotMoveStructCUBNormState::getCStateStringRepresentation() const {
		std::string strRepr;
		for (size_t i = 0; i < cStructure.size(); i++) {
			strRepr += cStructure[i];
		}
		return strRepr;
	}

	std::string
	CLatticeProteinPivotMoveStructCUBNormState::getUncomprStateStringRepresentation()
	 const {
		return getUncompressedStructStr();
	}

	State*
	CLatticeProteinPivotMoveStructCUBNormState::uncompressedClone() const {
		return new LatticeProteinPivotMoveStructCUBNormState(
					 getUncompressedStructStr(), false);
	}

	void
	CLatticeProteinPivotMoveStructCUBNormState::uncompress(State& state) const {
		dynamic_cast<LatticeProteinPivotMoveStructCUBNormState&>(state) =
		 LatticeProteinPivotMoveStructCUBNormState(getUncompressedStructStr(),
		  false);
	}

	CLatticeProteinPivotMoveStructCUBNormState*
	CLatticeProteinPivotMoveStructCUBNormState::readBinaryInputClone(std::ifstream& source)
	 const {

			// create new CLatticeProteinPivotMoveStructCUBNormState
		CLatticeProteinPivotMoveStructCUBNormState* cState =
		 new CLatticeProteinPivotMoveStructCUBNormState();

		size_t size;

			// read cStructure
		source.read(reinterpret_cast<char*>(&size), sizeof(size));
		cState->cStructure.resize(size);
		for (size_t i = 0; i < cState->cStructure.size(); i++) {
			source.read(reinterpret_cast<char*>(&(cState->cStructure[i])),
						  sizeof(cState->cStructure[i]));
		}

		return cState;
	}

	void
	CLatticeProteinPivotMoveStructCUBNormState::writeBinaryOutput(std::ofstream& destination)
	 const {
			// write cStructure
		size_t size = cStructure.size();
		destination.write(reinterpret_cast<const char*>(&size), sizeof(size));
		for (size_t i = 0; i < size; i++) {
			destination.write(reinterpret_cast<const char*>(&(cStructure[i])),
							   sizeof(cStructure[i]));
		}
	}

} // namespace ell
